; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Test if two dates are in chronological order.
; Return *T*, if the first date is 'before' the
; second one and otherwise *F*.
; -
; See DATE for a description of the date format.

; ---args---
; DATE1 - date
; DATE2 - date

; ---keywords---
; DATE-BEFORE-P function, date, time, chronological order
; predicate

; ---see-also---
; date, date-after-p, date-difference

; ---example---
; (date-before-p '(#1969 #7 #21) '(#1970 #1 #1))

:c lib/lessp.l
:c lib/greaterp.l
:c ext/date.l
;c ext/year-of.l
;c ext/month-of.l
;c ext/day-of.l

; ---code---
(defun date-before-p (date1 date2)
	(cond ((lessp (year-of date1) (year-of date2)) *t*)
		((greaterp (year-of date1) (year-of date2)) *f*)
		((lessp (month-of date1) (month-of date2)) *t*)
		((greaterp (month-of date1) (month-of date2)) *f*)
		(t (lessp (day-of date1) (day-of date2)))))

