; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the difference between two dates
; in days. The range covered by the dates given
; may not include the 15th of October in 1582,
; or the result will be wrong.
; -
; See DATE for a description of the date format.

; ---args---
; DATE1 - date
; DATE2 - date

; ---keywords---
; DATE-DIFFERENCE function, date, time, difference of dates

; ---see-also---
; date, date-before-p, date-to-days

; ---example---
; (date-difference '(#1969 #7 #21) '(#2000 #1 #1))

:c lib/difference.l
:c ext/date-before-p.l
:c ext/date-to-days.l

; ---code---
(defun date-difference (date1 date2)
	(cond ((date-before-p date1 date2)
			(difference (date-to-days date2)
				(date-to-days date1)))
		(t
			(difference (date-to-days date1)
				(date-to-days date2)))))
