; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Definition of the 'date' data structure.
; -
; Dates are lists of numbers. Order of year,
; month, day is in ISO format. For instance,
; July 23rd 1968 becomes '(#1968 #7 #23).

; ---args---
; DATE - date

; ---keywords---
; DATE structure, YEAR-OF function, MONTH-OF function
; DAY-OF function, date, time, days, months, years.

; ---see-also---
; date-to-days

; ---example---
; '(#2003 #4 #18)

:c lib/caar.l
;c lib/cadr.l
:c lib/caaar.l
;c lib/caddr.l

; ---code---
(defun year-of (date) (car date))

(defun month-of (date) (cadr date))

(defun day-of (date) (caddr date))
