; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Flatten a binary tree. Convert a binary tree to
; a flat list using depth first traversal.

; ---args---
; X - tree

; ---keywords---
; TREE-FLATTEN function, trees, flattening, lists

; ---see-also---
; tree-insert, tree-sort, tree-assoc, tree-balance

; ---example---
; (tree-flatten (list (list nil '#5 nil) '#7 (list nil '#9 nil)))

:c lib/caaar.l
;c lib/cadar.l
:c lib/caaaar.l
;c lib/caddar.l
:c lib/reverse.l

; ---code---
(defun tree-flatten (x)
	(label ((flatten (lambda (x r s)
		(cond ((null x)
				(cond ((null s) (reverse r))
					(t (flatten (caddar s) (cons (cadar s) r)
						(cdr s)))))
			(t
				(flatten (car x) r (cons x s)))))))
	(flatten x nil nil)))

