; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Insert a node into an ordered tree.

; ---args---
; X - value of node to insert
; TREE - tree
; P - predicate of desired order

; ---keywords---
; TREE-INSERT function, sorting, tree sort, ordering
; trees, ordered trees

; ---see-also---
; insert, tree-balance, tree-sort, tree-flatten, tree-assoc

; ---example---
; :l lib/lessp.l
; (tree-insert '#5 (list nil '#7 nil) lessp)

:c lib/caar.l
;c lib/cadr.l
:c lib/caaar.l
;c lib/caddr.l

; ---model---
; (defun tree-insert (x tree p)
;	(cond ((null tree) (list nil x nil))
;		((p x (cadr tree))
;			(list (tree-insert x (car tree) p)
;				(cadr tree) (caddr tree)))
;		(t
;			(list (car tree) (cadr tree)
;				(tree-insert x (caddr tree) p)))))

; ---code---
(defun tree-insert (x tree p)
	(label ((t-ins (lambda (tree)
		(cond ((null tree) (list nil x nil))
			((p x (cadr tree))
				(list (t-ins (car tree))
					(cadr tree) (caddr tree)))
			(t
				(list (car tree) (cadr tree)
					(t-ins (caddr tree))))))))
	(t-ins tree)))

