; ArrowLISP Extended Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Sort a list using tree sort. A predicate is used
; to define the desired order of members. It should
; return *T* for each two subsequent members in the
; desired order.

; ---args---
; X - list
; P - predicate

; ---keywords---
; TREE-SORT function, trees, lists, sorting, ordering,
; tree sort

; ---see-also---
; sort, tree-insert, tree-flatten, tree-assoc, tree-balance

; ---example---
; :l lib/lessp.l
; (tree-sort '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) lessp)

:c ext/tree-insert.l
:c ext/tree-flatten.l

; ---code---
(defun tree-sort (x p)
	(label ((sort-tree (lambda (x tree)
		(cond ((null x) (tree-flatten tree))
			(t (sort-tree (cdr x)
				(tree-insert (car x) tree p)))))))
	(sort-tree x nil)))

