; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the absolute value of an integer
; or natural number.

; ---args---
; X - number

; ---keywords---
; ABS function, absolute value, arithmetics, integer, natural

; ---see-also---
; digits, minus, minusp

; ---example---
; (abs '#-125)

:c lib/digits.l
:c lib/numerator.l
:c lib/denominator.l

; ---code---
(defun abs (x)
	(cond ((eq (car x) '-) (cdr x))
		((eq (car x) '+) (cdr x))
		((eq (car x) '/)
			(cond ((eq (car (numerator x)) '-)
					(list '/ (cdr (numerator x)) (denominator x)))
				(t x)))
		(t x)))

