; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Verify that at least one member of a list
; has a given property. Return *T*, if a
; member with the given property exists and
; otherwise *F*.

; ---args---
; A - list
; P - predicate to test desired property

; ---keywords---
; ANY function, property, predicate

; ---see-also---
; every, some, member, equal

; ---example---
; (any '((a b c) x (d e f)) atom)

; ---model---
; (defun any (x p)
;	(cond ((null x) *f*)
;		((p (car x)) *t*)
;		(t (any (cdr x) p))))

; ---code---
(defun any (x p)
	(label ((_any (lambda (x)
		(cond ((null x) *f*)
			((p (car x)) *t*)
			(t (_any (cdr x)))))))
	(_any x)))

