; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Append one list to the copy of another.

; ---args---
; A - list
; B - list to be appended

; ---keywords---
; APPEND function, lists, appending

; ---see-also---
; reverse, length, map, equal

; ---example---
; (append '(first second) '(third fourth))

:c lib/reverse.l

; ---model---
; (defun append (a b)
; 	(cond ((null a) b)
; 		(t (cons (car a) (append (cdr a) b)))))

; ---code---
(defun append (a b)
	(label ((app (lambda (a b)
		(cond ((null a) b)
			(t (app (cdr a) (cons (car a) b)))))))
	(app (reverse a) b)))
