; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Retrieve a binding from an association list.
; An association list is a list of pairs where
; the CAR part of each pair holds a key and
; the CDR part of the pair holds the value
; associated with that key:
; -
; ((key1.value1) ... (keyN.valueN))

; ---args---
; X - key of value to be found
; A - association list

; ---keywords---
; ASSOC function, association lists, alists, associate

; ---see-also---
; pair, sassoc, sublis, member, tree-assoc

; ---example---
; (assoc '3 '((1.i) (2.ii) (3.iii) (4.iv)))

:c lib/equal.l
:c lib/caar.l
;c lib/cdar.l

; ---model---
; (defun assoc (x a)
;	(cond ((null a) nil)
;		((equal (caar a) x) (car a))
;		(t (assoc x (cdr a)))))

; ---code---
(defun assoc (x a)
	(label ((asc (lambda (a)
		(cond ((null a) nil)
			((equal (caar a) x) (car a))
			(t (asc (cdr a)))))))
	(asc a)))

