; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Access elements of nested lists.

; ---args---
; X - list

; ---keywords---
; CAAAR, CAADR, CADAR, CADDR
; CDAAR, CDADR, CDDAR, CDDDR
; lists, selector, decomposition

; ---see-also---
; caaaar, caar

; ---example---
; (caddr '(first second third fourth fifth sixth seventh eighth))

; ---code---
(defun caaar (x) (car (car (car x))))
(defun caadr (x) (car (car (cdr x))))
(defun cadar (x) (car (cdr (car x))))
(defun caddr (x) (car (cdr (cdr x))))
(defun cdaar (x) (cdr (car (car x))))
(defun cdadr (x) (cdr (car (cdr x))))
(defun cddar (x) (cdr (cdr (car x))))
(defun cdddr (x) (cdr (cdr (cdr x))))
