; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the depth of a list. The depth
; of a list is the maximum number of nested
; lists enclosing any atom of the list.
; The depth of an atom is 0.

; ---args---
; A - list

; ---keywords---
; DEPTH function, list, member, depth, size

; ---see-also---
; count, length, append, copy

; ---example---
; (depth '(a b (c (d) e) ((f))))

:c lib/incr.l
:c lib/max.l
:c lib/mapcar.l

; ---code---
(defun depth (a)
	(cond ((atom a) '#0)
		(t (incr (max (mapcar a depth))))))
