; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Constants for represention of decimal digits.
; These constants are used to form natural,
; integer, and rational numbers used by arithmetic
; functions. The constants + and - are used for
; signs. / is used to introduce rational numbers.
; -
; For instance, the natural number 157 would be
; written as '#157. The integer 157 would be
; represented by '#+157 and -5 would be written
; as '#-5.
; -
; Rational numbers have the general form
; -
; (/ numerator denumerator)
; -
; where both the numerator and the denumerator
; may be natural numbers or integers. For instance,
; -2/3 would be written as '(/ #-2 #3).

; ---keywords---
; decimal digits, identity, numbers, digits, signs

; ---code---
(define digits '#0123456789)

(define + '+)
(define - '-)
(define / '/)

(define 0 '0)
(define 1 '1)
(define 2 '2)
(define 3 '3)
(define 4 '4)
(define 5 '5)
(define 6 '6)
(define 7 '7)
(define 8 '8)
(define 9 '9)
