; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compare two lists (s-expressions, in fact).
; Return *T*, if both expressions print equal.

; ---args---
; A - expression
; B - expression

; ---keywords---
; EQUAL function, equivalence, relation, comparison, predicate

; ---see-also---
; nequal, member, subst, any

; ---example---
; (equal '(a b (c d (e)) f) '(a b (c d (e)) f))

:c lib/logor.l

; ---model---
; (defun equal (a b)
;	(cond ((logor (atom a) (atom b)) (eq a b))
;		((equal (car a) (car b)) (equal (cdr a) (cdr b)))
;		(t *f*)))

; ---code---
(defun equal (a b)
	(label ((equ (lambda (a b ca cb)
 		(cond ((null a)
				(cond ((null b)
						(cond ((null ca) *t*)
							(t (equ (car ca) (car cb) (cdr ca) (cdr cb)))))
					(t *f*)))
			((logor (atom a) (atom b))
				(cond ((eq a b) (equ nil nil ca cb)) (t *f*)))
			(t (equ (car a) (car b) (cons (cdr a) ca)
				(cons (cdr b) cb)))))))
	(equ a b nil nil)))
