; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Verify that all members of a list have
; a given property. Return *T*, if all
; members have the requested property and
; *F*, if at least one member does not have
; the property.

; ---args---
; A - list
; P - predicate to test desired property

; ---keywords---
; EVERY function, property, predicate

; ---see-also---
; any, some, member, equal

; ---example---
; :l lib/numberp.l
; (every '(#5 #7 #12) numberp)

; ---model---
; (defun every (x p)
; 	(cond ((null x) *t*)
; 		((p (car x)) (every (cdr x) p))
; 		(t *f*)))

; ---code---
(defun every (x p)
	(label ((evr (lambda (x)
		(cond ((null x) *t*)
			((p (car x)) (evr (cdr x)))
			(t *f*)))))
	(evr x)))
