; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the X raised to the power of Y.
; Both X and Y must be natural numbers.

; ---args---
; X - list (base)
; Y - list (exponent)

; ---keywords---
; EXPT function, base, exponent, power

; ---see-also---
; digits, iexpt, rexpt, fac, gcd, product, sum

; ---example---
; (expt '#3 '#9)

(define expt t)

:c lib/digits.l
:c lib/zerop.l
:c lib/evenp.l
:c lib/times.l
:c lib/quotient.l
:c lib/decr.l

; ---model---
; (defun expt (x y)
;	(cond ((zerop y) '#1)
;		(t (times x (expt x (decr y))))))

; ---code---
(defun expt (x y)
	(label ((square (lambda (x) (times x x))))
	(cond ((zerop y) '#1)
		((evenp y)
			(square (expt x (quotient y '#2))))
		(t (times x (square (expt x (quotient y '#2))))))))
