; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Extract members from a list that match a given predicate.

; ---args---
; A - list
; P - predicate to match

; ---keywords---
; FILTER function, lists, filtering

; ---see-also---
; remove, some, every

; ---example---
; :l lib/numberp.l
; (filter '(abc #123 def #456 ghi) numberp)

:c lib/reverse.l

; ---model---
; (defun filter (a p)
;	(cond ((null a) nil)
;		((p (car a)) (cons (car a) (flt (cdr a) p)))
;			(t (flt (cdr a) p))))

; ---code---
(defun filter (a p)
	(label ((flt (lambda (a b)
		(cond ((null a) b)
			((p (car a)) (flt (cdr a) (cons (car a) b)))
			(t (flt (cdr a) b))))))
	(flt (reverse a) nil)))
