; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the greatest common divisor (GCD)
; of two natural or integer numbers. This
; function uses Euclid's Algorithm.

; ---args---
; A - number
; B - number

; ---keywords---
; GCD function, gcd, greatest common divisor
; Euclid, Euclid's algorithm, arithmetics, integer

; ---see-also---
; digits, expt, fac, product, sum

; ---example---
; (gcd '#99 '#-77)

(define gcd t)

:c lib/abs.l
:c lib/natural.l
:c lib/zerop.l
:c lib/remainder.l
:c lib/lessp.l

; ---code---
(defun gcd (a b)
	(label ((_gcd (lambda (a b)
		(cond ((zerop b) a)
			((lessp a b) (_gcd a (remainder b a)))
			(t (_gcd b (remainder a b)))))))
	(_gcd (natural (abs a)) (natural (abs b)))))

