; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if an expression X is the head of an
; expression Y.

; ---args---
; X - potential head
; Y - expression

; ---keywords---
; HEADP function, list, pair, head

; ---see-also---
; tailp, caar, listp

; ---example---
; (headp '(a b c) '(a b c d e f))

:c lib/equal.l

; ---code---
(defun headp (x y)
	(cond ((null y) (null x))
		((null x) *t*)
		((equal (car x) (car y)) (headp (cdr x) (cdr y)))
		(t *f*)))
