; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute A hyperN B.
; A, B, and N must all be natural numbers.

; ---args---
; N - list (order)
; A - list (base)
; B - list (hyper-exponent)

; ---keywords---
; HYPER function, hyper, hyper4, hyper5, base, exponent, power
; power tower

; ---see-also---
; digits, expt, iexpt, rexpt, fac

; ---example---
; (hyper '#4 '#3 '#3)

(define hyper t)

:c lib/digits.l
:c lib/equal.l
:c lib/incr.l
:c lib/plus.l
:c lib/onep.l
:c lib/times.l
:c lib/expt.l
:c lib/decr.l
:c lib/greaterp.l

; ---code---
(defun hyper (n a b)
	(cond ((equal n '#0) (incr b))
		((equal n '#1) (plus a b))
		((onep b) a)
		((equal n '#2) (times a b))
		((equal n '#3) (expt a b))
		((equal n '#4) (expt a (hyper n a (decr b))))
		((greaterp n '#4) (hyper (decr n) a (hyper n a (decr b))))))

; (defun hyper4 (a b) (hyper '#4 a b))

; (defun hyper5 (a b) (hyper '#5 a b))
