; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Subtract two integer numbers.

; ---args---
; A - integer number
; B - integer number (to be subtracted)

; ---keywords---
; IDIFFERENCE function, difference, subtract, subtraction
; arithmetics, integer

; ---see-also---
; digits, difference, rdifference, iplus, iquotient, iremainder
; itimes, minus

; ---example---
; (idifference '#5 '#7)

(define idifference t)

:c lib/digits.l
:c lib/abs.l
:c lib/lessp.l
:c lib/iplus.l
:c lib/difference.l
:c lib/integer.l

; ---code---
(defun idifference (a b)
	(label

	((idiff (lambda (a b)
		(cond ((eq (car b) '-)
				(iplus a (abs b)))		; B<0
			((eq (car a) '-)
				(iplus a (minus b)))	; B>=0, A<0
			((lessp (cdr a) (cdr b))
				(cons '- (difference (cdr b) (cdr a))))		; A>=0, B>=0, A<B
			(t (difference (cdr a) (cdr b)))))))			; A>=0, B>=0, A>=B

	(idiff (integer a) (integer b))))
