; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Divide two integer numbers, giving a
; result of the form (quotient remainder).

; ---args---
; A - integer number (dividend)
; B - integer number (divisor)

; ---keywords---
; IDIVIDE function, quotient, modulus, division, divide
; arithmetics, integer

; ---see-also---
; digits, divide, rquotient, iquotient, iremainder, iplus
; idifference, itimes

; ---example---
; (idivide '#11 '#-2)

(define idivide t)

:c lib/digits.l
:c lib/lessp.l
:c lib/zerop.l
:c lib/caar.l
;c lib/cadr.l
:c lib/divide.l
:c lib/integer.l

; ---code---
(defun idivide (a b)
	(label

	((sign (lambda (x)
		(cond ((eq (car (integer a)) (car (integer b))) x)
			(t (cons '- x)))))

	(idiv (lambda (a b)
		(cond ((zerop b) (bottom 'idivide-by-zero))
			; overflow?
			((lessp (cdr a) (cdr b)) (list '#0 (sign (cdr a))))
			; compute quotient, remainder
			(t (label ((q (divide (cdr a) (cdr b))))
				(list (sign (car q))
						(sign (cadr q)))))))))

	(idiv (integer a) (integer b))))
