; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the maximum of a set/list. Integer version.
; The list may not be empty.

; ---args---
; A - list of integers

; ---keywords---
; IMAX function, maximum, comparison, arithmetics, integer

; ---see-also---
; digits, imin, max, igreaterp

; ---example---
; (imax '(#-25 #5 #25 #0 #-5))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/igreaterp.l

; ---code---
(defun imax (a)
	(cond ((null (cdr a)) (car a))
		((igreaterp (car a) (cadr a))
			(imax (cons (car a) (cddr a))))
		(t (imax (cdr a)))))
