; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the minimum of a set/list. Integer version.
; The list may not be empty.

; ---args---
; A - list of integers

; ---keywords---
; IMIN function, minimum, comparison, arithmetics, integer

; ---see-also---
; digits, imax, min, ilessp

; ---example---
; (imin '(#-25 #5 #25 #0 #-5))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/ilessp.l

; ---code---
(defun imin (a)
	(cond ((null (cdr a)) (car a))
		((ilessp (car a) (cadr a))
			(imin (cons (car a) (cddr a))))
		(t (imin (cdr a)))))
