; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Insert a member into an ordered list.
; The predicate P must be asymmetrical
; and evaluate to T for each two
; subsequent members of A.

; ---args---
; X - member to insert
; A - ordered list
; P - predicate defining the order of A

; ---keywords---
; INSERT function, sorting, insertion sort
; ordering, lists, ordered lists

; ---see-also---
; remove, sort, orderedp

; ---example---
; :l lib/lessp.l
; (insert '#4 '(#3 #5) lessp)

:c lib/append.l
:c lib/reverse.l

; ---model---
; (defun insert (x a p)
;	(cond ((null a) (cons x nil))
;		((p x (car a)) (cons x a))
;		(t (cons (car a) (insert x (cdr a) p)))))

; ---code---
(defun insert (x a p)
	(label ((ins (lambda (a r)
		(cond ((null a) (reverse (cons x r)))
			((p x (car a)) (append (reverse (cons x r)) a))
			(t (ins (cdr a) (cons (car a) r)))))))
	(ins a nil)))
