; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Convert a natural, integer, or rational number
; to an integer. Rationals must be reducable to
; integers in order to convert them.

; ---args---
; A - number

; ---keywords---
; INTEGER function, numeric, numbers, digits, natural, integer

; ---see-also---
; digits, natural, rational, integerp, numberp

; ---example---
; (integer '#567)

:c lib/digits.l
:c lib/normalize.l

; ---code---
(defun integer(a)
	(cond ((eq (car a) '+) a)
		((eq (car a) '-) a)
		((eq (car a) '/)
			(label ((i (normalize a)))
				(cond ((eq (car i) '/)
						(bottom (list 'integer a)))
					(t i))))
		(t (cons '+ a))))
