; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the intersection of two sets.
; Sets are represented by lists of unique
; members.

; ---args---
; A - set
; B - set

; ---keywords---
; INTERSECTION function, intersection
; sets, set theory

; ---see-also---
; union, member, remove, unique, any

; ---example---
; (intersection '(ab cd ef) '(ef bc ab))

:c lib/member.l
:c lib/reverse.l

; ---model---
; (defun intersection (a b)
;	(cond ((null a) nil)
;		((member (car a) b)
;			(cons (car a) (intersection (cdr a) b)))
;		(t (intersection (cdr a) b))))

; ---code---
(defun intersection (a b)
	(label ((isec (lambda (a r)
		(cond ((null a) (reverse r))
			((member (car a) b)
				(isec (cdr a) (cons (car a) r)))
			(t (isec (cdr a) r))))))
	(isec a nil)))
