; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Generate a sequence of natural numbers.
; The resulting sequence starts with '#1
; and is in ascending order.

; ---args---
; N - maximum number in sequence.

; ---keywords---
; IOTA function, sequence of numbers, arithmetics, natural

; ---see-also---
; digits, sum, product, sort, unsort

; ---example---
; (iota '#10)

:c lib/digits.l
:c lib/append.l
:c lib/natural.l
:c lib/decr.l
:c lib/zerop.l

; ---model---
; (defun iota(x)
; 	(cond ((zerop x) nil)
; 		(t (append (iota (decr x)) (list x)))))

; ---code---
(defun iota(x)
	(label ((j (lambda (x r)
		(cond ((zerop x) r)
			(t (j (decr x) (cons x r)))))))
	(j (natural x) nil)))

