; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Add two integer numbers.

; ---args---
; A - integer number
; B - integer number

; ---keywords---
; IPLUS function, plus, sum, addition, arithmetics, integer

; ---see-also---
; digits, plus, rplus, idifference, iquotient, iremainder
; itimes

; ---example---
; (iplus '#-55 '#-77)

(define iplus t)

:c lib/digits.l
:c lib/abs.l
:c lib/minus.l
:c lib/greaterp.l
:c lib/logand.l
:c lib/idifference.l
:c lib/plus.l
:c lib/integer.l

; ---code---
(defun iplus (a b)
	(label ((_iplus (lambda (a b)
		; A>=0, B>=0: A+B => |A|+|B|
		(cond ((logand (eq (car a) '+) (eq (car b) '+))
				(plus (cdr a) (cdr b)))
			; A>=0, B<0
			((logand (eq (car a) '+) (eq (car b) '-))
				; |A|>|B| => A-|B|
				(cond ((greaterp (cdr a) (cdr b)) (idifference a (abs b)))
					; |A|<=|B| => -(|B|-A)
					(t (minus (idifference (abs b) a)))))
			; A<0, B>=0
			((logand (eq (car a) '-) (eq (car b) '+))
				; |A|>|B| => -(|A|-B)
				(cond ((greaterp (cdr a) (cdr b))
						(minus (idifference (abs a) b)))
					; |A|<=|B| => B-|A|
					(t (idifference b (abs a)))))
			; A<0, B<0 => -(|A|+|B|)
			(t (cons '- (plus (cdr a) (cdr b))))))))

	(_iplus (integer a) (integer b))))
