; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Sort a list using insertion sort. A predicate is
; used to define the desired order of members. It
; should return *T* for each two members in the
; desired order.

; ---args---
; A - list to sort
; P - predicate

; ---keywords---
; ISORT function, sorting, ordering, insertion sort

; ---see-also---
; insert, sort, quicksort, orderedp

; ---example---
; :l lib/lessp.l
; (isort '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) lessp)

:c lib/insert.l

; ---model---
; (defun isort (a p)
;	(cond ((null a) nil)
;		(t (insert (car a) (isort (cdr a) p) p))))

; ---code---
(defun isort (a p)
	(label ((srt (lambda (a r)
		(cond ((null a) r)
			(t (srt (cdr a) (insert (car a) r p)))))))
	(srt a nil)))
