; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the product of two integer numbers.

; ---args---
; A - integer number (factor 1)
; B - integer number (factor 2)

; ---keywords---
; ITIMES function, times, multiply, multiplication, product
; arithmetics, integer

; ---see-also---
; digits, times, rtimes, iplus, idifference, iquotient
; iremainder

; ---example---
; (itimes '#12 '#3)

(define itimes t)

:c lib/digits.l
:c lib/minus.l
:c lib/integer.l
:c lib/times.l

; ---code---
(defun itimes (a b)
	(label ((_itimes (lambda (a b)
		; avoid leading zeroes in result
		(cond ((zerop a) '#0)
			; handle signs
			((eq (car (integer a)) (car (integer b)))
				(times (cdr a) (cdr b)))
			(t (minus (times (cdr a) (cdr b))))))))
	(_itimes (integer a) (integer b))))
