; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the length of a list. The result is a
; natural number.

; ---args---
; X - list

; ---keywords---
; LENGTH function, lists, length

; ---see-also---
; digits, count, depth, append, reverse

; ---example---
; (length '(a b c d e f))

:c lib/incr.l

; ---model---
; (defun length (x)
;	(cond ((null x) '#0)
;		(t (incr (length (cdr x))))))

; ---code---
(defun length (x)
	(label ((len (lambda (x r)
		(cond ((null x) r)
			(t (len (cdr x) (incr r)))))))
	(len x '#0)))
