; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if an expression is a (proper) list.
; Proper lists are:
; -
; NIL, cons[X;NIL], cons[Y;cons[X;NIL]], etc.

; ---args---
; X - expression

; ---keywords---
; LISTP function, atom, non-atom, list, pair

; ---see-also---
; pairp, litatom

; ---example---
; (listp '(a b c))

; ---model---
; (defun listp (x)
;	(cond ((null x) *t*)
;		((atom x) *f*)
;		(t (listp (cdr x)))))

; ---code---
; THIS FUNCTION WILL FAIL TO DETECT IMPROPER LISTS
; [LISTS OF THE FORM (X ... Y.Z)]. HOWEVER, IMPROPER LISTS
; ARE NOT DEFINED IN ARROW LISP, ANYWAY.
(defun listp (x)
	(cond ((null x) *t*)
		((atom x) *f*)
		((null (cdr x)) *t*)
		((atom (cdr x)) *f*)
		(t t)))
