; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Map two lists into one using a given function.
; The function must take two arguments. If the
; lists have different lengths, only N pairs are
; mapped where N is the length of the shorter one
; of the lists.

; ---args---
; X - list
; Y - list
; F - function

; ---keywords---
; MAP function, mapping, lists

; ---see-also---
; mapcar, maplis, reduce

; ---example---
; (map '(a b c) '(d e f) cons)

:c lib/reverse.l

; ---model---
; (defun map (x y f)
;	(cond ((null x) nil)
;		((null y) nil)
;		(t (cons (f (car x) (car y))
;			(map (cdr x) (cdr y) f)))))

; ---code---
(defun map (x y f)
	(label ((_map (lambda (x y r)
		(cond ((null x) r)
			((null y) r)
			(t (_map (cdr x) (cdr y)
				(cons (f (car x) (car y)) r)))))))
	(reverse (_map x y nil))))
