; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Apply a function to each member of a list.

; ---args---
; A - list
; F - function to apply to each member

; ---keywords---
; MAPCAR function, mapping, lists, CAR

; ---see-also---
; map, maplis, reduce

; ---example---
; :l lib/minus.l
; (mapcar '(#1 #2 #3) minus)

:c lib/reverse.l

; ---model---
; (defun mapcar (a f)
;	(cond ((null t) b)
;		(t (cons (f (car a)) (mapcar (cdr a) f)))))

; ---code---
(defun mapcar (a f)
	(label ((mapc (lambda (a b)
		(cond ((null a) b)
			(t (mapc (cdr a) (cons (f (car a)) b)))))))
	(mapc (reverse a) nil)))
