; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Apply a function to each CDR of a list.

; ---args---
; A - list
; F - function to apply to each sublist

; ---keywords---
; MAPLIS function, mapping, lists, CDR

; ---see-also---
; map, mapcar, reduce

; ---example---
; :l lib/reverse.l
; (maplis '(#1 #2 #3) reverse)

:c lib/reverse.l

; ---model---
; (defun maplis (a f)
;	(cond ((null t) b)
;		(t (cons (f (cdr a)) (maplis (cdr a) f)))))

; ---code---
(defun maplis (a f)
	(label ((mapl (lambda (a b)
		(cond ((null a) (reverse b))
			(t (mapl (cdr a) (cons (f a) b)))))))
	(mapl a nil)))
