; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the maximum of a set/list. Natural version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; MAX function, maximum, comparison, arithmetics, natural

; ---see-also---
; digits, min, imax, rmax, greaterp

; ---example---
; (max '(#22 #33 #11))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/greaterp.l

; ---code---
(defun max (a)
	(cond ((null (cdr a)) (car a))
		((greaterp (car a) (cadr a))
			(max (cons (car a) (cddr a))))
		(t (max (cdr a)))))
