; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if a list has a member that is identical
; to a given symbol.

; ---args---
; X - symbol to find
; A - list

; ---keywords---
; MEMB function, member of, sets, set theory

; ---see-also---
; member, union, intersection, unique, any

; ---example---
; (memb 'c '(a b c d e f))

; ---model---
; (defun memb (x a)
; 	(cond ((null a) *f*)
; 		((eq (car a) x) t)
; 		(t (memb x (cdr a)))))

; ---code---
(defun memb (x a)
	(label ((mmb (lambda (a)
		(cond ((null a) *f*)
			((eq (car a) x) t)
			(t (mmb (cdr a)))))))
	(mmb a)))
