; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if a list has a member that is
; equal to a given S-expression.

; ---args---
; X - expression to find
; A - list

; ---keywords---
; MEMBER function, member of, sets, set theory

; ---see-also---
; memb, union, intersection, unique, any

; ---example---
; (member '(c d) '(a b (c d) e f))

:c lib/equal.l

; ---model---
; (defun member (x a)
;	(cond ((null a) *f*)
;		((equal (car a) x) t)
;		(t (member x (cdr a)))))

; ---code---
(defun member (x a)
	(label ((mem (lambda (a)
		(cond ((null a) *f*)
			((equal (car a) x) t)
			(t (mem (cdr a)))))))
	(mem a)))
