; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the minimum of a set/list. Natural version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; MIN function, minimum, comparison, arithmetics, natural

; ---see-also---
; digits, max, imin, rmin, lessp

; ---example---
; (min '(#22 #33 #11))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/lessp.l

; ---code---
(defun min (a)
	(cond ((null (cdr a)) (car a))
		((lessp (car a) (cadr a))
			(min (cons (car a) (cddr a))))
		(t (min (cdr a)))))
