; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the negative value of a number.

; ---args---
; X - number

; ---keywords---
; MINUS function, negative value, sign, arithmetics
; integer, rational

; ---see-also---
; digits, minusp, difference, idifference, rdifference, abs

; ---example---
; (minus '#567)

:c lib/digits.l
:c lib/zerop.l
:c lib/numerator.l
:c lib/denominator.l

; ---code---
(defun minus (x)
	(cond ((zerop x) x)
		((eq (car x) '+) (cons '- (cdr x)))
		((eq (car x) '-) (cdr x))
		((eq (car x) '/)
			(list '/ (minus (numerator x)) (denominator x)))
		(t (cons '- x))))

