; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Convert an integer, natural, or rational number
; to a natural number. Integers must be positive
; and rationals must be reducable to positive
; integers in order to convert them

; ---args---
; A - number

; ---keywords---
; NATURAL function, numeric, numbers, digits, natural
; integer, rational

; ---see-also---
; digits, integer, rational, naturalp, numberp

; ---example---
; (natural '#+567)

:c lib/digits.l
:c lib/integer.l

; ---code---
(defun natural(a)
	(cond ((eq (car a) '+) (cdr a))
		((eq (car a) '-) (bottom (list 'natural a)))
		((eq (car a) '/) (natural (integer a)))
		(t a)))
