; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Extract the tail of a list beginning at the n'th
; member of that list. The first element has the
; position '#1. Retrieving the '#0'th element of the
; list results in cons[NIL;X].

; ---args---
; X - list
; N - position of member to extract

; ---keywords---
; NTH function, list, n'th member, position

; ---see-also---
; caar, last, append

; ---example---
; (nth '(a b c d e f) '#3)

:c lib/onep.l
:c lib/zerop.l
:c lib/decr.l

; ---code---
(defun nth (x n)
	(cond ((null x) nil)
		((zerop n) (cons nil x))
		((onep n) x)
		(t (nth (cdr x) (decr n)))))
