; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Test if an S-expression represents a
; number. See DIGITS for the definitions
; of natural, integer, and rational numbers.

; ---args---
; A - expression

; ---keywords---
; NUMBERP function, numeric, numbers, digits, predicate

; ---see-also---
; digits, naturalp, integerp, rationalp, zerop, minusp

; ---example---
; (numberp '#-123)

:c lib/digits.l
:c lib/member.l
:c lib/caar.l
;c lib/cddr.l
:c lib/numerator.l
:c lib/denominator.l

; ---code---
(defun numberp (a)
	(label ((nump (lambda (a)
		(cond ((atom a) *f*)
				((member (car a) digits)
					(cond ((null (cdr a)) t)
						(t (nump (cdr a)))))
			(t *f*))))
	(inump (lambda (a)
		(cond ((eq (car a) '+) (nump (cdr a)))
			((eq (car a) '-) (nump (cdr a)))
			(t (nump a))))))
	(cond ((atom a) *f*)
		((eq (car a) '/)
			(cond ((null (cdr a)) *f*)
				((null (cddr a)) *f*)
				((inump (numerator a)) (nump (denominator a)))
				(t *f*)))
		(t (inump a)))))
