; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Test a number for being one.

; ---args---
; X - number

; ---keywords---
; ONEP function, one , numbers, digits, equivalence
; identity, predicate

; ---see-also---
; digits, zerop, evenp, numberp, minusp

; ---example---
; (onep '#1)

:c lib/digits.l
:c lib/equal.l
:c lib/normalize.l
:c lib/naturalp.l

; ---code---
(defun onep (x)
	(cond ((eq (car x) 1) (null (cdr x)))
		((eq (car x) '/)
			(label ((i (normalize x)))
				(cond ((naturalp i) (onep i))
					(t *f*))))
		(t (equal x '#+1))))
