; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if the members of a list
; are in a given monotonic order.

; ---args---
; X - list
; P - predicate defining order

; ---keywords---
; ORDEREDP function, ordered, ordering, relation
; lists, predicate

; ---see-also---
; insert, sort, unsort

; ---example---
; :l lib/greaterp.l
; (orderedp '(#9 #8 #7 #6 #5) greaterp)

:c lib/caar.l
;c lib/cadr.l

; ---model---
; (defun orderedp (x p)
; 	(cond ((null x) *t*)
; 		((null (cdr x)) *t*)
; 		((p (car x) (cadr x)) (orderedp (cdr x) p))
; 		(t *f*)))

; ---code---
(defun orderedp (x p)
	(label ((odp (lambda (x)
		(cond ((null x) *t*)
			((null (cdr x)) *t*)
			((p (car x) (cadr x)) (odp (cdr x)))
			(t *f*)))))
	(odp x)))
