; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Build an association list from two lists.

; ---args---
; X - list containing keys
; Y - list containing values

; ---keywords---
; PAIR function, assocation lists, alists, associate

; ---see-also---
; assoc, sassoc, tree-assoc

; ---example---
; (pair '(1 2 3) '(i ii iii))

;c lib/reverse.l
:c lib/map.l

; ---model---
; (defun pair (x y)
;	(cond ((null x) nil)
;		((null y) nil)
;		(t (cons (cons (car x) (car y)) (pair (cdr x) (cdr y))))))

; ---model---
; ; TAIL-RECURSIVE VERSION
; (defun pair (x y)
;	(label ((par (lambda (x y r)
;		(cond ((null x) r)
;			((null y) r)
;			(t (par (cdr x) (cdr y) (cons (cons (car x) (car y)) r)))))))
;	(reverse (par x y nil))))

; ---code---
(defun pair (a b) (map a b cons))
