; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the product of a sequence of
; positive numbers.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; PRODUCT function, product of sequence

; ---see-also---
; digits, expt, fac, gcd, sum

; ---example---
; (product '#5 '#7)

(define product t)

:c lib/digits.l
:c lib/equal.l
:c lib/greaterp.l
:c lib/times.l
:c lib/incr.l
:c lib/natural.l

; ---model---
; (defun product(n m)
;	(cond ((equal n m) m)
;			(t (times n (product (incr n) m)))))

; ---code---
(defun product(n m)
	(label ((nn (natural n)) (lim (natural m))
	(prod (lambda (n r)
		(cond ((greaterp n lim) r)
			(t (prod (incr n) (times n r)))))))
	(cond ((greaterp nn lim) (bottom 'product-range))
		(t (prod nn '#1)))))
