; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Test if a number is a rational number.
; See DIGITS for definitions of numbers.

; ---args---
; A - number

; ---keywords---
; RATIONALP function, numeric, numbers, digits, predicate, rational

; ---see-also---
; digits, rational, naturalp, integerp, numberp, zerop

; ---example---
; (rationalp '(/ #2 #3))

:c lib/digits.l
:c lib/caar.l
;c lib/cddr.l
:c lib/neq.l

; ---code---
(defun rationalp(a)
	(cond ((neq (car a) '/) *f*)
		((null (cdr a)) *f*)
		((null (cddr a)) *f*)
		(t *t*)))
