; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Subtract two rational numbers.

; ---args---
; A - rational number
; B - rational number

; ---keywords---
; RDIFFERENCE function, minus, difference, subtraction
; arithmetics, rational

; ---see-also---
; digits, difference, idifference, rplus, rquotient, rtimes, minus

; ---example---
; (rdifference '(/ #2 #3) '(/ #5 #6))

(define rdifference t)

:c lib/digits.l
:c lib/rational.l
:c lib/equalize.l
:c lib/caar.l
;c lib/cadr.l
:c lib/numerator.l
:c lib/denominator.l
:c lib/idifference.l
:c lib/normalize.l

; ---code---
(defun rdifference (a b)
	(label ((factors (equalize (rational a) (rational b)))
	(rsub (lambda (a b)
		(normalize (list '/
			(idifference (numerator a) (numerator b))
			(denominator a))))))
	(rsub (car factors) (cadr factors))))
