; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Reduce a list. Combine the first member of the
; list with the reduced rest of the list using a
; given function.

; ---args---
; A - list to reduce
; X - default member (replaces NIL)
; F - combining function

; ---keywords---
; REDUCE function, reduction, reduce lists

; ---see-also---
; map, mapcar, maplis

; ---example---
; :l lib/plus.l
; (reduce '(#1 #2 #3 #4) '#5 plus)

:c lib/reverse.l

; ---model---
; (defun reduce (a x f)
;	(cond ((null a) x)
;		(t (f (car a) (reduce (cdr a) x f)))))

; ---code---
(defun reduce (a x f)
	(label ((red (lambda (a b)
		(cond ((null a) b)
			((null b) (red (cdr a) (f (car a) x)))
			(t (red (cdr a) (f (car a) b)))))))
	(red (reverse a) nil)))
