; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Remove members from lists.

; ---args---
; A - list
; P - predicate to match members to remove

; ---keywords---
; REMOVE function, lists, sets, set theory, member, remove

; ---see-also---
; insert, filter, member, any

; ---example---
; :l lib/numberp.l
; (remove '(abc #123 def #456 ghi) numberp)

:c lib/reverse.l

; ---model---
; (defun remove (a p)
;	(cond ((null a) nil)
;		((p (car a)) (cdr a))
;		(t (cons (car a) (remove (cdr a) p)))))

; ---code---
(defun remove (a p)
	(label ((rem (lambda (a r)
		(cond ((null a) (reverse r))
			((p (car a)) (rem (cdr a) r))
			(t (rem (cdr a) (cons (car a) r)))))))
	(rem a nil)))
