; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if two rational numbers are in ascending
; order. Return *T*, if A<B and otherwise *F*.

; ---args---
; A - rational number
; B - rational number

; ---keywords---
; RLESSP function, less than, ordering, relation
; comparison, predicate, rational

; ---see-also---
; digits, rnlessp, lessp, ilessp, rgreaterp, equal

; ---example---
; (rlessp '(/ #2 #3) '(/ #4 #5))

:c lib/rational.l
:c lib/equalize.l
:c lib/numerator.l
:c lib/ilessp.l
:c lib/caar.l
;c lib/cadr.l

; ---code---
(defun rlessp (a b)
	(label ((factors (equalize (rational a) (rational b))))
		(ilessp (numerator (car factors))
				(numerator (cadr factors)))))
