; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the maximum of a set/list. Rational version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; RMAX function, maximum, comparison, arithmetics, rational

; ---see-also---
; digits, rmin, max, imax, rgreaterp

; ---example---
; (rmax '((/ #1 #2) (/ #2 #3) (/ #4 #5)))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/rgreaterp.l

; ---code---
(defun rmax (a)
	(cond ((null (cdr a)) (car a))
		((rgreaterp (car a) (cadr a))
			(rmax (cons (car a) (cddr a))))
		(t (rmax (cdr a)))))
