; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Find the minimum of a set/list. Rational version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; RMIN function, minimum, comparison, arithmetics, rational

; ---see-also---
; digits, rmax, min, imin, rlessp

; ---example---
; (rmin '((/ #1 #2) (/ #2 #3) (/ #4 #5)))

:c lib/caar.l
;c lib/cadr.l
;c lib/cddr.l
:c lib/rlessp.l

; ---code---
(defun rmin (a)
	(cond ((null (cdr a)) (car a))
		((rlessp (car a) (cadr a))
			(rmin (cons (car a) (cddr a))))
		(t (rmin (cdr a)))))
