; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Add two rational numbers.

; ---args---
; A - rational number
; B - rational number

; ---keywords---
; RPLUS function, plus, sum, addition, arithmetics, rational

; ---see-also---
; digits, plus, iplus, rdifference, rquotient, rtimes

; ---example---
; (rplus '(/ #2 #3) '(/ #5 #6))

(define rplus t)

:c lib/digits.l
:c lib/rational.l
:c lib/equalize.l
:c lib/caar.l
;c lib/cadr.l
:c lib/numerator.l
:c lib/denominator.l
:c lib/iplus.l
:c lib/normalize.l

; ---code---
(defun rplus (a b)
	(label ((factors (equalize (rational a) (rational b)))
	(radd (lambda (a b)
		(normalize
			(list '/
				(iplus (numerator a) (numerator b))
				(denominator a))))))
	(radd (car factors) (cadr factors))))
