; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Divide two rational numbers.

; ---args---
; A - rational number
; B - rational number

; ---keywords---
; RQUOTIENT function, divided by, quotient, division, arithmetics
; rational

; ---see-also---
; digits, quotient, iquotient, rplus, rdifference, rtimes

; ---example---
; (rquotient '(/ #2 #3) '(/ #5 #6))

(define rquotient t)

:c lib/digits.l
:c lib/rational.l
:c lib/equalize.l
:c lib/caar.l
;c lib/cadr.l
:c lib/numerator.l
:c lib/denominator.l
:c lib/itimes.l
:c lib/normalize.l

; ---code---
(defun rquotient (a b)
	(label ((rdiv (lambda (a b)
		(normalize
			(list '/
				(itimes (numerator a) (denominator b))
				(itimes (denominator a) (numerator b)))))))
	(cond ((zerop b) (bottom (list 'rquotient a b)))
		(t (rdiv (rational a) (rational b))))))
