; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Multiply two rational numbers.

; ---args---
; A - rational number
; B - rational number

; ---keywords---
; RTIMES function, times, product, multiplication, arithmetics
; rational

; ---see-also---
; digits, times, itimes, rplus, rdifference, rquotient

; ---example---
; (rtimes '(/ #2 #3) '(/ #5 #6))

(define rtimes t)

:c lib/digits.l
:c lib/rational.l
:c lib/caar.l
;c lib/cadr.l
:c lib/numerator.l
:c lib/denominator.l
:c lib/itimes.l
:c lib/normalize.l

; ---code---
(defun rtimes (a b)
	(label ((rmul (lambda (a b)
		(normalize
			(list '/
				(itimes (numerator a) (numerator b))
				(itimes (denominator a) (denominator b)))))))
	(rmul (rational a) (rational b))))
