; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Retrieve a binding from an association list, providing a
; default value. For a definition of association lists, see
; ASSOC.

; ---args---
; X - key to find
; Y - association list to search
; C - constant function to apply if X not in Y

; ---keywords---
; SASSOC function, association lists, alists, associate, default

; ---see-also---
; assoc, pair, sublis, tree-assoc

; ---example---
; (sassoc iv '((i.1) (ii.2) (iii.3)) (lambda () nil))

:c lib/caar.l
;c lib/cdar.l

; ---model---
; (defun sassoc (x y c)
;	(cond ((null y) (c))
;		((eq (caar y) x) (car y))
;		(t (sassoc x (cdr y) c))))

; ---code---
(defun sassoc (x y c)
	(label ((sas (lambda (y)
		(cond ((null y) (c))
			((eq (caar y) x) (car y))
			(t (sas (cdr y)))))))
	(sas y)))
