; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Extract the tail of a list where the first
; member of the tail has a given property.
; Evaluate to NIL if no such member exists.

; ---args---
; A - list
; P - predicate defining property to find

; ---keywords---
; SOME function, property, predicate

; ---see-also---
; any, every, member, remove, unique

; ---example---
; (some '((a b c) x (d e f)) atom)

; ---model---
; (defun some (x p)
; 	(cond ((null x) nil)
; 		((p (car x)) x)
; 		(t (some (cdr x) p))))

; ---code---
(defun some (x p)
	(label ((som (lambda (x)
		(cond ((null x) nil)
			((p (car x)) x)
			(t (som (cdr x)))))))
	(som x)))
