; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Compute the sum of a sequence of positive numbers.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; SUM function, sum of sequence

; ---see-also---
; digits, expt, fac, gcd, product

; ---example---
; (sum '#2 '#5)

(define sum t)

:c lib/digits.l
:c lib/equal.l
:c lib/greaterp.l
:c lib/natural.l
:c lib/incr.l
:c lib/decr.l
:c lib/plus.l
:c lib/times.l
:c lib/quotient.l
:c lib/difference.l

; ---model---
; (defun sum(n m)
;	(cond ((equal n m) m)
;			(t (plus n (sum (incr n) m)))))

; ---code---
(defun sum(n m)
	(label ((nn (natural n)) (nm (natural m))
	(_sum (lambda (n m)
		(label ((x (incr (difference m n))))
			(plus
				(quotient
					(plus (times x x) x)
					'#2)
				(times (decr n) x))))))
	(cond ((greaterp nn nm) (bottom 'sum-range))
		(t (_sum nn nm)))))
