; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Check if an expression X is the tail of an
; expression Y.

; ---args---
; X - potential tail
; Y - expression

; ---keywords---
; TAILP function, list, pair, tail

; ---see-also---
; headp, caar, listp

; ---example---
; (tailp '(d e f) '(a b c d e f))

:c lib/equal.l

; ---model---
; (defun tailp (x y)
;	(cond ((null y) (null x))
;		((equal x y) *t*)
;		(t (tailp x (cdr y)))))

; ---code---
(defun tailp (x y)
	(label ((tlp (lambda (y)
		(cond ((null y) (null x))
			((equal x y) *t*)
			(t (tlp (cdr y)))))))
	(tlp y)))
