; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Transform a list into a set (a list containing
; only unique elements).

; ---args---
; A - list

; ---keywords---
; UNIQUE function, unique, sets, set theory, lists

; ---see-also---
; intersection, union, member, remove, any

; ---example---
; (unique '(alpha beta beta gamma delta alpha))

:c lib/member.l
:c lib/reverse.l

; ---model---
; (defun unique (a)
;	(cond ((null a) a)
;		((member (car a) (cdr a)) (unique (cdr a)))
;		(t (cons (car a) (unique (cdr a))))))

; ---code---
(defun unique (a)
	(label ((uni (lambda (a r)
		(cond ((null a) (reverse r))
			((member (car a) r) (uni (cdr a) r))
			(t (uni (cdr a) (cons (car a) r)))))))
	(uni a nil)))
