; ArrowLISP Library
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Test a number for being zero. A rational number
; is zero, if its numerator is zero.

; ---args---
; X - number

; ---keywords---
; ZEROP function, zero, numbers, digits, equivalence
; identity, predicate

; ---see-also---
; digits, onep, evenp, numberp, minusp, plusp

; ---example---
; (zerop '#+0)

:c lib/digits.l
:c lib/equal.l
:c lib/numerator.l

; ---code---
(defun zerop (x)
	(cond ((eq (car x) 0) (null (cdr x)))
		((eq (car x) '/) (zerop (numerator x)))
		(t (equal x '#+0))))
