; ArrowLISP Example Program
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Sort a list using the bubblesort algorithm.

; ---args---
; X - list to sort
; P - predicate defining the desired order

; ---keywords---
; BUBBLESORT function, bubble sort, sorting, example

; ---example---
; :l lib/lessp.l
; (bubblesort '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) lessp)

:l lib/caar.l
;l lib/cadr.l
;l lib/cddr.l
:l lib/orderedp.l

; ---code---
(defun bubblesort (x p)
	(label ((bubble-up (lambda (x)
		(cond ((null x) nil)
			((null (cdr x)) x)
			((p (car x) (cadr x))
				(cons (car x) (bubble-up (cdr x))))
			(t (cons (cadr x) (bubble-up (cons (car x) (cddr x))))))))
	(bubble-step (lambda (x)
		(cond ((orderedp x p) x)
			(t (bubble-step (bubble-up x)))))))
	(bubble-step x)))
