; ArrowLISP Example Program
; Copyright (C) 1998-2004 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Solve the 'Towers of Hanoi'.

; ---args---
; N - list containing one member per disk

; ---keywords---
; HANOI function, Towers of Hanoi, example

; ---example---
; (hanoi '#iiiii)

:l lib/append.l

; ---code---
(defun hanoi (n)
	(label ((_hanoi (lambda (from to via n)
		(cond ((null n) nil)
			(t (append (_hanoi from via to (cdr n))
				(append (list (list from to))
					(_hanoi via to from (cdr n)))))))))
	(_hanoi 'a 'b 'c n)))
