; M-Expression Example Program
; Copyright (C) 2004,2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; ---purpose---
; Solve the Towers of Hanoi, M-expression version.

; ---keywords---
; M-expression, Towers of Hanoi, MEXPRC

; ---example---
; :l src/mexprc.l
; :l src/hanoi.m
; (m-expr-compile **)
; (eval **)
; (m-expr-eval '( hanoi[4] ))

; ---code---
'(
hanoi[n] :=
	solve[%LEFT, %MIDDLE, %RIGHT, n]
	where
	solve[from, to, via, n] :=
		[n=0-> nil:
			make_move[solve[from, via, to, n-1],
				list[list[from, to]],
				solve[via, to, from, n-1]]]
	and
	make_move[a, b, c] :=
		append[a, append[b, c]]
)

